import { createEvent, fireEvent, render, screen } from '@testing-library/react';
import { Handlers } from './Handlers';
import { Point } from './types';
describe('The Handlers component ', () => {
  test('is just an empty div', () => {
    const transformMap = (
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) => {};
    render(<Handlers  />);
    // screen.debug();
    const handlers = screen.getByRole('presentation');
    // screen.debug();
    expect(handlers).toMatchInlineSnapshot(`
<div
  class="handler"
  role="presentation"
/>
`);
  });
/*   test('handle mouseDown / mouseMove events', () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(
      handlers,
      createEvent.mouseDown(handlers, {
        clientX: 10,
        clientY: 20,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    // screen.debug();
    expect(transformMapParams).toMatchInlineSnapshot(`
Arguments [
  Object {
    "x": 10,
    "y": 30,
  },
  null,
  null,
]
`);
  });
  test('does *not* handle mouseMove events not preceded by a mouseDown', () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    // screen.debug();
    expect(transformMapParams).toBeUndefined();
  });

  test('A mouseUp event disable further mouseMove events', () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(
      handlers,
      createEvent.mouseDown(handlers, {
        clientX: 10,
        clientY: 20,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseUp(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    // screen.debug();
    expect(transformMapParams).toBeUndefined();
  });

  test('A mouseLeave event disable further mouseMove events', () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(handlers, createEvent.mouseOver(handlers));
    fireEvent(handlers, createEvent.mouseEnter(handlers));
    fireEvent(
      handlers,
      createEvent.mouseDown(handlers, {
        clientX: 10,
        clientY: 20,
      })
    );
    fireEvent(handlers, createEvent.mouseOut(handlers));
    fireEvent(handlers, createEvent.mouseLeave(handlers));
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    // screen.debug();
    expect(transformMapParams).toBeUndefined();
  });

  test('throttle mouseMove events', () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(
      handlers,
      createEvent.mouseDown(handlers, {
        clientX: 10,
        clientY: 20,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 30,
        clientY: 60,
      })
    );
    // screen.debug();
    expect(transformMapParams).toMatchInlineSnapshot(`
Arguments [
  Object {
    "x": 10,
    "y": 30,
  },
  null,
  null,
]
`);
  });

  test('throttle mouseMove events', async () => {
    var transformMapParams: any;
    function transformMap(
      deltaShift: Point | null,
      deltaZoom: number | null,
      zoomCenter: Point | null
    ) {
      console.log(`transformMap${JSON.stringify(arguments)}`);
      transformMapParams = arguments;
    }
    render(<Handlers transformMap={transformMap} />);
    const handlers = screen.getByRole('presentation');
    fireEvent(
      handlers,
      createEvent.mouseDown(handlers, {
        clientX: 10,
        clientY: 20,
      })
    );
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 20,
        clientY: 50,
      })
    );
    await new Promise((r) => setTimeout(r, 500));
    fireEvent(
      handlers,
      createEvent.mouseMove(handlers, {
        clientX: 5,
        clientY: 5,
      })
    );
    // screen.debug();
    expect(transformMapParams).toMatchInlineSnapshot(`
Arguments [
  Object {
    "x": -15,
    "y": -45,
  },
  null,
  null,
]
`);
  }); */
});
